## Remove `stable` from Docker images

Previously, we were including our very old and very deprecated dependency management tool `stable` in our `ponyc` Docker images. We've stopped.

## Fix broken linking when using a sanitizer

The internal link command used when building a Pony program with a sanitizer in place wasn't correctly generated and linking the program would fail. This has been fixed.

## Fix memory errors with some `--debug` program builds

When we upgraded to LLVM 15, we accidentally changed the optimization level applied to `--debug` builds. That change in optimization levels surfaced a rather complicated bug that we've been looking into. The end result? Some programs would crash with memory errors like segfaults or bad access.

We've updated to go back to the optimization setup we had with LLVM 14. We recommend updating your `ponyc` installation as soon as possible.

